/*
 *  Copyright 2012 Anyware Services
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */

Ext.namespace('org.ametys.odf.sync');

org.ametys.odf.sync.GlobalSynchronizationReportToolFactory = function(id, config, pluginName) 
{
	org.ametys.odf.sync.GlobalSynchronizationReportToolFactory.superclass.constructor.call(this, id, config, pluginName);
};

Ext.extend(org.ametys.odf.sync.GlobalSynchronizationReportToolFactory, org.ametys.uitool.tool.ToolFactory, {});

/**
 * The prefix used to generate the tool id.
 * @type {String} 
 * @private
 * @constant
 */
org.ametys.odf.sync.GlobalSynchronizationReportToolFactory._toolIdPrefix = "odf-synchro-report-";

org.ametys.odf.sync.GlobalSynchronizationReportToolFactory.prototype.openTool = function (params)
{
	if (org.ametys.uitool.ToolsManager.getInstance().getTool(org.ametys.odf.sync.GlobalSynchronizationReportToolFactory._toolIdPrefix + params.id) == null)
	{
		// Tool does not exists => Tool creation
		this._config['title'] = params.id;
		var tool = new org.ametys.odf.sync.GlobalSynchronizationReportTool (org.ametys.odf.sync.GlobalSynchronizationReportToolFactory._toolIdPrefix + params.id, this.getPluginName());
		
		tool.setConfiguration(this._config);
		tool.setFactory (this);
		
		org.ametys.uitool.ToolsManager.getInstance().addUITool (tool, this._config['default-location']);
	}
	else
	{
		// Tool does already exists => Tool activation
		tool = org.ametys.uitool.ToolsManager.getInstance().getTool(org.ametys.odf.sync.GlobalSynchronizationReportToolFactory._toolIdPrefix + params.id);
	}

	tool.setParams(params);
	tool.activate();

	return tool;
}

/**
 * Destroy the tool.
 * @param {org.ametys.uitool.tool.Tool} tool The tool to close.
 */
org.ametys.odf.sync.GlobalSynchronizationReportToolFactory.prototype.closeTool = function (tool)
{
	org.ametys.uitool.ToolsManager.getInstance().removeUITool (tool);
}